#include "apache.h"
//#include "/local/omar/PathCrawler/lib/assume.h"

//#undef  pathcrawler_label
//#define pathcrawler_label(cond)   {} // DSE(p)
//#define pathcrawler_label(cond)   { if(cond) {printf("\nlabelCondTrue('%s:%d')\n",__FILE__, __LINE__);} } // DSE(p')
// DSE(p*) tout commenter + disable_label_history(yes)
// DSE*(p*) tout commenter + disable_label_history(no)

int loopcnt; 
#define CHKLOOP {if(++loopcnt >= 5) return NULL;}
int ap_isspace(char c)
{

  pathcrawler_label(c == '\t');
  pathcrawler_label(c != '\t');
  pathcrawler_label(c == '\n');
  pathcrawler_label(c != '\n');
  pathcrawler_label(c == '\v');
  pathcrawler_label(c != '\v');
  pathcrawler_label(c == '\f');
  pathcrawler_label(c != '\f');
  pathcrawler_label(c == '\r');
  pathcrawler_label(c != '\r');
  pathcrawler_label(c == ' ');
  pathcrawler_label(c != ' ');

  if (c == '\t'
      || c == '\n'
      || c == '\v'
      || c == '\f'
      || c == '\r'
      || c == ' ')
    return 1;

  return 0;
}

int ap_tolower(char c)
{
  // do we have tolower() in our stubs?
  return c;
}

// Rewritten to be more analyzable -- use explicit array indexing. 
char * ap_cpystrn(char *dst, const char *src, size_t dst_size)
{
  int i;

  if (dst_size == 0)
    return (dst);
  
  for (i = 0; i < dst_size - 1; i++) {
    dst[i] = src[i];
    if (src[i] == EOS) {
      return dst + i;
    }
  }

  dst[i] = EOS;

  return dst + i;
}

/*@ requires \valid(tag+(0..6)) ; // direct translation of the test_parameters
  @ requires \valid(nondetEntry+(0..99)) ;
  @ requires \forall integer i ; 0 <= i <= 99 ==> (
    (nondetEntry[i] >= 'a' && nondetEntry[i] <= 'z')
    || nondetEntry[i] == '\t'
    || nondetEntry[i] == '\n'
    || nondetEntry[i] == 0x0B // '\v' (bug frama-c)
    || nondetEntry[i] == '\f'
    || nondetEntry[i] == '\r'
    || nondetEntry[i] == ' '
    || nondetEntry[i] == '>'
    || nondetEntry[i] == '<'
    || nondetEntry[i] == '='
    || nondetEntry[i] == '\''
    || nondetEntry[i] == '"'
    || nondetEntry[i] == '\\'
    ) ;
  @ requires tagbuf_len == 3 ;
@*/
char *get_tag(char *tag, int tagbuf_len, char *nondetEntry)
//char *get_tag(char *tag, int tagbuf_len)
{
  char *tag_val, c, term;
  int t, indice=0;
  loopcnt = 0;
  t = 0;

  --tagbuf_len;
	
  do {
    CHKLOOP
    //if(indice==100) indice = 0;
    //c = nondetEntry[indice]; indice++;
    GET_CHAR(c, NULL);
  } while (ap_isspace(c));

  if (c == '-') {
    //if(indice==100) indice = 0;
    //c = nondetEntry[indice]; indice++;
    GET_CHAR(c, NULL);
    if (c == '-') {
      do {
        CHKLOOP
        //if(indice==100) indice = 0;
        //c = nondetEntry[indice]; indice++;
        GET_CHAR(c, NULL);
      } while (ap_isspace(c));
      if (c == '>') {
        ap_cpystrn(tag, "done", tagbuf_len);
        return tag;
      }
    }
    return NULL;
  }

  while (1) {
    CHKLOOP
    if (t == tagbuf_len) {
      tag[t] = EOS;
      return NULL;
    }


    int tmp = ap_isspace(c); 

    pathcrawler_label(c == '=' );
    pathcrawler_label(c != '=' );
    pathcrawler_label(tmp == 0);
    pathcrawler_label(tmp != 0);    


    //pathcrawler_label(c == '=' && tmp);   // trivially uncoverable
    pathcrawler_label(c == '=' && !tmp);
    pathcrawler_label(c != '=' && tmp);
    pathcrawler_label(c != '=' && !tmp);


    if (c == '=' || tmp) {
      break;
    }
    tag[t] = ap_tolower(c);
    t++;
    
    //if(indice==100) indice = 0;
    //c = nondetEntry[indice]; indice++;
    GET_CHAR(c, NULL);
  }

  tag[t] = EOS;
  t++;
  tag_val = tag + t;

  while (ap_isspace(c)) {
    CHKLOOP
    //if(indice==100) indice = 0;
    //c = nondetEntry[indice]; indice++;
    GET_CHAR(c, NULL);
  }
  if (c != '=') {
    return NULL;
  }

  do {
    CHKLOOP
    //if(indice==100) indice = 0;
    //c = nondetEntry[indice]; indice++;
    GET_CHAR(c, NULL);
  } while (ap_isspace(c));


  pathcrawler_label(c != '"');
  pathcrawler_label(c == '"');
  pathcrawler_label(c != '\'');
  pathcrawler_label(c == '\'');


  pathcrawler_label(c != '"' && c != '\'');
  pathcrawler_label(c != '"' && c == '\'');
  pathcrawler_label(c == '"' && c != '\'');
  // pathcrawler_label(c == '"' && c == '\'');   // trivially uncoverable


  if (c != '"' && c != '\'') {
    return NULL;
  }
  term = c;
  while (1) {
    CHKLOOP
    //if(indice==100) indice = 0;
    //c = nondetEntry[indice]; indice++;
    GET_CHAR(c, NULL);
    if (t == tagbuf_len) { /* Suppose t == tagbuf_len - 1 */
      tag[t] = EOS;
      return NULL;
    }

    if (c == '\\') {
      /* BAD */
      //pathcrawler_assert( t>=0 );
      //pathcrawler_assert( t<pathcrawler_dimension(tag) );
      tag[t] = c;
      t++;               /* Now t == tagbuf_len */
      
      //if(indice==100) indice = 0;
      //c = nondetEntry[indice]; indice++;
      GET_CHAR(c, NULL);
    }
    else if (c == term) {
      break;
    }

    /* BAD */
    //pathcrawler_assert( t>=0 );
    //pathcrawler_assert( t<pathcrawler_dimension(tag) );
    tag[t] = c;    
    t++;                /* Now t == tagbuf_len + 1 
                         * So the bounds check (t == tagbuf_len) will fail */
  }
  /* BAD */

  //pathcrawler_assert( t>=0 );
  //pathcrawler_assert( t<pathcrawler_dimension(tag) );
  tag[t] = EOS;

  return tag;
}

/*
int main ()
{
  char tag[MAX_STRING_LEN];

  // The caller always passes in (tag, sizeof(tag)) 
  get_tag (tag, MAX_STRING_LEN);

  return 0;
}

*/

//frama-c-gui -val -main get_tag iter1_prefixLong_arr_bad.c
//frama-c-gui -addErrorBranches -slice-all-threats -main get_tag iter1_prefixLong_arr_bad.c


